<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';

$sql_levels = "SELECT l.id_level, l.label, l.order, l.class_name, l.icon, l.status FROM levels l WHERE l.status = 1 ORDER BY l.order";

$result_levels = mysqli_query($conn,$sql_levels);

if(!$result_levels){
    http_response_code(500);
    die(json_encode([
        'debug' => 'erro na query, ' . $sql_levels
    ],JSON_UNESCAPED_UNICODE));
}

$json_levels = [];

while($row_level = mysqli_fetch_assoc($result_levels)){
    //DEFINE DADOS DO LEVEL
    $id_level = $row_level['id_level'];
    $label_level = $row_level['label'];
    $order_level = $row_level['order'];
    $class_level = $row_level['class_name'];
    $icon_level = $row_level['icon'];
    
    $json_levels[$label_level]['id'] = $id_level;
    $json_levels[$label_level]['order'] = $order_level;
    $json_levels[$label_level]['colorClass'] = $class_level;
    $json_levels[$label_level]['iconClass'] = $icon_level;

    // BUSCA DADOS DAS UNITS
    $sql_units = "SELECT u.label, u.id_unit, u.order FROM units u WHERE u.id_level = '${id_level}' AND u.status = 1;";

    $result_units = mysqli_query($conn,$sql_units);

    if(!$result_units){
        http_response_code(500);
        die(json_encode([
            'debug' => 'erro na query, ' . $sql_units
        ],JSON_UNESCAPED_UNICODE));
    }

    while($row_unit = mysqli_fetch_assoc($result_units)){
        $label_unit = $row_unit['label'];
        $order_unit = $row_unit['order'];
        $id_unit = $row_unit['id_unit'];

        // DEFINE DADOS DA UNIT
        $json_levels[$label_level]['units'][$label_unit]['order'] = $order_unit;
        $json_levels[$label_level]['units'][$label_unit]['id'] = $id_unit;

    }

    http_response_code(200);
    die(json_encode($json_levels,JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));
}

die();

    echo '
    {
        "Foundations":{
            "id": 1,
            "order": 1,
            "colorClass": "red",
            "iconClass": "twt-circle",
            "units":{
                "Unit 1":{
                    "order":1,
                    "id":33,
                    "grade": 97,
                    "progress": 100
                },
                "Unit 2":{
                    "order":2,
                    "id":11,
                    "grade": 97,
                    "progress": 100
                },
                "Unit 3":{
                    "order":3,
                    "id":22,
                    "grade": 97,
                    "progress": 100
                },
                "Unit 4":{
                    "order":4,
                    "id":55,
                    "grade": 97,
                    "progress": 100
                },
                "Unit 5":{
                    "order":5,
                    "id":44,
                    "grade": 97,
                    "progress": 100
                },
                "Unit 6":{
                    "order":6,
                    "id":66,
                    "grade": 97,
                    "progress": 100
                },
                "Unit 7":{
                    "order":7,
                    "id":77,
                    "grade": 97,
                    "progress": 100
                },
                "Unit 8":{
                    "order":8,
                    "id":88,
                    "grade": 97,
                    "progress": 100
                },
                "Unit 9":{
                    "order":9,
                    "id":99,
                    "grade": 97,
                    "progress": 50
                },
                "Unit 10":{
                    "order":10,
                    "id":10,
                    "grade": 97,
                    "progress": 0
                }
            }
        },
        "Discovery":{
            "id": 2,
            "order": 2,
            "colorClass": "orange",
            "iconClass": "twt-square",
            "units":{
                "Unit 11":{
                    "order":1,
                    "id":12,
                    "grade": 97,
                    "progress": 100
                },
                "Unit 12":{
                    "order":2,
                    "id":13,
                    "grade": 97,
                    "progress": 100
                },
                "Unit 13":{
                    "order":3,
                    "id":15,
                    "grade": 97,
                    "progress": 100
                },
                "Unit 14":{
                    "order":4,
                    "id":14,
                    "grade": 97,
                    "progress": 100
                },
                "Unit 15":{
                    "order":5,
                    "id":16,
                    "grade": 97,
                    "progress": 100
                },
                "Unit 16":{
                    "order":6,
                    "id":17,
                    "grade": 97,
                    "progress": 100
                },
                "Unit 17":{
                    "order":7,
                    "id":18,
                    "grade": 97,
                    "progress": 100
                },
                "Unit 18":{
                    "order":8,
                    "id":19,
                    "grade": 97,
                    "progress": 100
                },
                "Unit 19":{
                    "order":9,
                    "id":20,
                    "grade": 97,
                    "progress": 50
                },
                "Unit 20":{
                    "order":10,
                    "id":23,
                    "grade": 97,
                    "progress": 0
                }
            }
        }
    }';

?>