<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_user = mysqli_real_escape_string($conn,$json['id_user']);

if(empty($json['id_unit'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_unit'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_unit = mysqli_real_escape_string($conn,$json['id_unit']);

if(empty($json['section_data'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'section_data'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$section_data = $json['section_data'];

if(isset($section_data['label'])){
    $label = mysqli_real_escape_string($conn,$section_data['label']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'label'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}


if(isset($section_data['order'])){
    $order = mysqli_real_escape_string($conn,$section_data['order']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'order'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(isset($section_data['icon'])){
    $icon = mysqli_real_escape_string($conn,$section_data['icon']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'icon'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if($order == 1){
    // GET MAX ORDER
    $sql_order = "SELECT max(`order`) as max_order FROM sections WHERE id_unit = '{$id_unit}'";
    
    $result_order = mysqli_query($conn,$sql_order);
    
    if(!$result_order){
        $error = mysqli_error($conn);
        http_response_code(500);
        mysqli_rollback($conn);
        mysqli_close($conn);
        die(json_encode([
            'debug' => $error
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    
    $row_order = mysqli_fetch_assoc($result_order);
    $max_order = $row_order['max_order'];
    $order = intval($max_order) + 1;
}else{
    $order = 0;
}


// TEST USER PERMITION

        $test_editor_permition = test_editor_permition($conn,$id_user);
    if($test_editor_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_editor_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_editor_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'editor permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

    $test_permition = test_permition($conn,$id_user,1);
    if($test_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    
//

$sql_create = "CALL sp_create_section('{$id_user}','{$id_unit}','{$label}','{$icon}',{$order},1)";

$result_create = mysqli_query($conn,$sql_create);

if(!$result_create){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error,
        'debug_sql' => $sql_create
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

http_response_code(200);
mysqli_commit($conn);
mysqli_close($conn);

die();

?>

